#ifndef Liste_h
#define Liste_h

#include "Cell.h"

class Liste
{
  public:
  // definition du type Place, synonyme de Cell*
    typedef Cell* Place;

  private:
  // attributs
    int nbElem;
    Place tete, queue;

  public:
    Liste();
    virtual ~Liste();

  private:
  //methodes privees
    virtual void setPremier(Place);
    virtual void setDernier(Place);
    virtual void setSuivant(Place p,Place nouvSuiv);
    virtual void setPrecedent(Place p, Place nouvPrec);
    virtual Place recherche(float)const;
    virtual Place rechercheApres(float d, Place cherche)const;

  public:
  //primitives
    virtual Place premier()const;
    virtual Place dernier()const;
    virtual Place suivant(Place)const;
    virtual Place precedent(Place)const;

  //utilitaires
    virtual bool estVide()const;
    virtual int longueur()const;
    virtual void vider();

  //operations courantes liees uniquement a la structure de la liste
    virtual void ajoutApres(Place, Place);
    virtual void ajoutAvant(Place, Place);
    virtual void enleve(Place);
    virtual void insere(Place);
    virtual void insereChercheApres(Place p, Place courant);
};

#endif
