#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifndef MSWINDOWS
  #include <time.h>
#endif
#include "Liste.h"

//-------Compilation conditionnelle----------------------
//#define verbose //affiche les sorties texte
//#define gnuplot //affiche les graphiques avec gnuplot
//#define NO_ROUTE //dsactive le routage
//-------Fin compilation conditionnelle------------------

//-------Compilation conditionnelle compilateur----------------
//#define MSWINDOWS //parties windows
//#define EXP1 //exprience 1
//#define EXP2 //exprience 2
//#define EXP3 //exprience 3
//#define EXP4 //exprience 4
//-------Fin compilation conditionnelle compilateur------------

#ifdef EXP1
  #define SUJET \
  cout<<"<H1>Exprience&nbsp;1</H1>"<<endl; \
  cout<<"<UL>"<<endl; \
  cout<<"<LI>Les paquets arrivent selon des processus de Poisson;</LI>"<<endl; \
  cout<<"<LI>Le temps de service des paquets dans chaque file d'attente est une dure alatoire de distribution exponentielle de moyenne 1ms.</LI>"<<endl; \
  cout<<"<LI>Les dures de service d'un mme paquet dans diffrentes files sont supposes tre indpendantes.</LI>"<<endl; \
  cout<<"</UL>"<<endl;
#endif
#ifdef EXP2
  #define SUJET \
  cout<<"<H1>Exprience&nbsp;2</H1>"<<endl; \
  cout<<"<UL>"<<endl; \
  cout<<"<LI>Les paquets arrivent selon des processus priodiques de priode t = 1ms, interrompus par des priodes &lt;&lt;off&gt;&gt;.</LI>"<<endl; \
  cout<<"<LI>La dure des priodes &lt;&lt;on&gt;&gt; est constante et vaut 20ms.</LI>"<<endl; \
  cout<<"<LI>La dure des priodes &lt;&lt;off&gt;&gt; est alatoire, de distribution exponentielle dont la moyenne est calcule pour que le dbit global soit celui spcifi par la topologie;</LI>"<<endl; \
  cout<<"<LI>Le temps de service des paquets dans chaque file d'attente est comme dans l'exprience 1.</LI>"<<endl; \
  cout<<"</UL>"<<endl;
  #define ONOFF //active les priodes off
#endif
#ifdef EXP3
  #define SUJET \
  cout<<"<H1>Exprience&nbsp;3</H1>"<<endl; \
  cout<<"<UL>"<<endl; \
  cout<<"<LI>Les paquets arrivent comme dans l'exprience 2;</LI>"<<endl; \
  cout<<"<LI>Le temps de service des paquets dans chaque file d'attente est constant de dure 1ms.</LI>"<<endl; \
  cout<<"</UL>"<<endl;
  #define ONOFF //active les priodes off
  #define SERVICE_CONST //temps de service constant
#endif
#ifdef EXP4
  #define SUJET \
  cout<<"<H1>Exprience&nbsp;4</H1>"<<endl; \
  cout<<"<UL>"<<endl; \
  cout<<"<LI>Dans cette exprience, le rseau est comme dans l'exprience 3.</LI>"<<endl; \
  cout<<"<LI>Les files d'attente ont une capacit limite  100 paquets.</LI>"<<endl; \
  cout<<"<LI>Mesurer le taux de perte des paquets, pour chaque file d'attente et pour chaque route.</LI>"<<endl; \
  cout<<"</UL>"<<endl;
  #define ONOFF //active les priodes off
  #define SERVICE_CONST //temps de service constant
  #define FILE_LIMIT //taille de la file limite
#endif

//-------Constantes--------------------------------------------------------------------------------
const int NBFILES = 6; //nombre de files
const int NMax = 10000; //1  19000 en statique //nombre de clients gnrs
const float lambda0 = 0.01; //0.01  0.06 //loi de poisson pour les arrives
const float delai_arrive = 0.00015; //delai entre la fin de traitement dans une file et l'arrive dans une autre
const float lamb_traitement = 1.0; //lambda pour la dure de traitement
#ifdef ONOFF
  const float dureeOn = 20.0; //dure priode on constante
  const float interOn = 1.0; //inter-arrives en on
#endif
#ifdef FILE_LIMIT
  int capaciteFile = 100; //capacit limite de la file
#endif
//-------Fin Constantes----------------------------------------------------------------------------

const int TOPO1 = 0;
const int TOPOALEA = 1;

struct TDateClient
{
  float date;
  int nbClients;
};
TDateClient **tabValeurs;

//Fonction de sauvegarde d'un tableau dans fichier
void toFic(char* fichier, TDateClient* tab, int maxi)
{
  FILE* desc;
  desc=fopen(fichier,"w+");
  for(int i=0; i<maxi; i++)
    fprintf(desc,"%.12f %d\n", tab[i].date, tab[i].nbClients);
  fclose(desc);
}

void ecrireDansFichier(char * fichier, char * texte)
{
  FILE* desc;
  desc=fopen(fichier,"w+");
  fprintf(desc,"%s\n", texte);
  fclose(desc);
}

float max(float i, float j)
{
  return  ( i > j ) ? i : j;
}

int max(int i, int j)
{
  return  ( i > j ) ? i : j;
}

#ifdef MSWINDOWS
  float aleatoire()
  {
    return 1.0-((rand()+0.01)/((float)RAND_MAX+1.001));
  }

  int aleatoireEntier(int a)
  {
    return rand() % a;
  }
#else
  float aleatoire()
  {
    return 1.0-(random()/((float)RAND_MAX+1.0));
  }

  int aleatoireEntier(int a)
  {
    return random() % a;
  }

  void randomize()
  {
    srandom(time(NULL));
  }
#endif

void programme(int topologie, float lamb)
{
  //TDateClient tabValeurs[NBFILES][NB_MESSAGES]; //statique
  int id = 0; //identifiant disponible
  int indice[NBFILES];
  for (int cpt=0; cpt<NBFILES; cpt++)  indice[cpt] = 0;
  int nbGenere[NBFILES];
  for (int cpt=0; cpt<NBFILES; cpt++)  nbGenere[cpt] = 0;
  float cumulReponses[NBFILES]; //cumul des temps de rponses par file
  for (int cpt=0; cpt<NBFILES; cpt++) cumulReponses[cpt] = 0.0;
  float dateDerniereArrivee[NBFILES]; //date de la dernire arrive dans chaque file
  for (int cpt=0; cpt<NBFILES; cpt++) dateDerniereArrivee[cpt] = 0.0;
  #ifdef ONOFF
    int nbOn[NBFILES]; //nombre de processus restant  arriver dans la priode on
    for (int cpt=0; cpt<NBFILES; cpt++) nbOn[cpt] = 0;
  #endif
  float cumulInterArrivees[NBFILES]; //cumul des inter-arrives par file
  for (int cpt=0; cpt<NBFILES; cpt++) cumulInterArrivees[cpt] = 0.0;
  float cumulTo[NBFILES]; //cumul des temps de traitement par file
  for (int cpt=0; cpt<NBFILES; cpt++) cumulTo[cpt] = 0.0;
  int nbMaxClientsAttente[NBFILES]; //nombre maximum constat de clients en attente par file
  for (int cpt=0; cpt<NBFILES; cpt++) nbMaxClientsAttente[cpt] = 0;
  int pertesFile[NBFILES]; //nombre de pertes de paquets constates par file
  for (int cpt=0; cpt<NBFILES; cpt++) pertesFile[cpt] = 0;
  float dateLibre[NBFILES]; //represente la prochaine date libre dans le systeme qui permettra de prendre un nouveau client
  for (int cpt=0; cpt<NBFILES; cpt++) dateLibre[cpt] = 0.0;
  int nbClient[NBFILES];  //nombre de clients dans chaque systme
  for (int cpt=0; cpt<NBFILES; cpt++) nbClient[cpt] = 0;
  int nbClientServis[NBFILES];  //nombre de clients passs par une file
  for (int cpt=0; cpt<NBFILES; cpt++) nbClientServis[cpt] = 0;
  int nbReponsesSup10[NBFILES]; //nombre de rponses par file dont le temps de rponse dpasse 10
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesSup10[cpt] = 0;
  int nbReponsesSup20[NBFILES]; //nombre de rponses par file dont le temps de rponse dpasse 20
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesSup20[cpt] = 0;
  int nbReponsesSup50[NBFILES]; //nombre de rponses par file dont le temps de rponse dpasse 50
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesSup50[cpt] = 0;
  int tableRandoms[NBFILES];  //vrification des statistiques de random
  for (int cpt=0; cpt<NBFILES; cpt++) tableRandoms[cpt] = 0;
  float cumulReponsesRoutes[NBFILES]; //cumul des temps de rponses par route
  for (int cpt=0; cpt<NBFILES; cpt++) cumulReponsesRoutes[cpt] = 0.0;
  float debitArriveesRoutes[NBFILES]; //dbit des arrives par route
  for (int cpt=0; cpt<NBFILES; cpt++) debitArriveesRoutes[cpt] = 0.0;
  int pertesRoute[NBFILES]; //nombre de pertes de paquets constates par route
  for (int cpt=0; cpt<NBFILES; cpt++) pertesRoute[cpt] = 0;
  int nbReponsesRoutesSup10[NBFILES]; //nombre de rponses par route dont le temps de rponse dpasse 10
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesRoutesSup10[cpt] = 0;
  int nbReponsesRoutesSup20[NBFILES]; //nombre de rponses par route dont le temps de rponse dpasse 20
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesRoutesSup20[cpt] = 0;
  int nbReponsesRoutesSup50[NBFILES]; //nombre de rponses par route dont le temps de rponse dpasse 50
  for (int cpt=0; cpt<NBFILES; cpt++) nbReponsesRoutesSup50[cpt] = 0;

  // cration file d'arrivee des processus
  Liste* pile = new Liste();

  //gnration d'un processus initial par file
  for (int cpt=0; cpt<NBFILES; cpt++)
  {
    float date = -log(aleatoire()) / (lamb*(cpt+1)); //calcule une inter-arrive //LogE(random(1))
    pile->insere(new Cell(cpt, id, 'A', date, cpt, date, date, true));
    id++;
    nbGenere[cpt]++;
    #ifdef ONOFF
      nbOn[cpt] = (int)(dureeOn / interOn); //on commence par une priode on
    #endif
  }

  Cell* test=pile->premier();
  while (!pile->estVide())
  {
    pile->enleve(test);
    #ifdef verbose
      cerr<<"NFile="<<test->getNumFile()<<" type="<<test->getType()<<" n"<<test->getNumProc()<<" dateArrFile="<<test->getDateArrFile()<<" date="<<test->getDate()<<" source="<<test->getSource()<<endl;
    #endif
    int numFile = test->getNumFile();
    switch(test->getType())
    {
      case 'A':
      {
        #ifdef FILE_LIMIT
          if (nbClient[numFile]<capaciteFile)
          {
        #endif
            //Gestion du nombre de clients dans le systme
            nbClient[numFile]++;
            nbClientServis[numFile]++;
            tabValeurs[numFile][indice[numFile]].date = test->getDate();
            tabValeurs[numFile][indice[numFile]].nbClients = nbClient[numFile];
            if (nbClient[numFile]>nbMaxClientsAttente[numFile])  nbMaxClientsAttente[numFile] = nbClient[numFile];
            indice[numFile]++;
            //Insertion du dbut et fin du processus
            cumulInterArrivees[numFile] += test->getDate() - dateDerniereArrivee[numFile]; //peut-tre  mettre hors du FILE_LIMIT
            dateDerniereArrivee[numFile] = test->getDate();
            dateLibre[numFile]=max(dateLibre[numFile], test->getDate());
            #ifdef SERVICE_CONST
              float to = lamb_traitement; //dure de service dans le systme
            #else
              float to = -log(aleatoire()) / (1.0 / lamb_traitement); //dure de service dans le systme
            #endif
            cumulTo[numFile]+=to;
            //Cell* depart=new Cell(numFile,test->getNumProc(), 'D', dateLibre[numFile], test->getSource(), test->getDateArrReseau(), test->getDateArrFile());
            //pile->insere(depart);
            dateLibre[numFile]+=to;
            Cell* fin=new Cell(numFile,test->getNumProc(), 'F', dateLibre[numFile], test->getSource(), test->getDateArrReseau(), test->getDateArrFile(), test->isNouveau());
            pile->insere(fin);
        #ifdef FILE_LIMIT
          }
          else //on perd des paquets
          {
            pertesFile[numFile]++;
            pertesRoute[test->getSource()]++;
          }
        #endif

        //s'il reste des paquets  gnrer au niveau de cette file
        if ((nbGenere[numFile]<NMax) && test->isNouveau())
        {
          #ifdef ONOFF
            float date; //calcule une inter-arrive
            if (nbOn[numFile]>0) date = interOn; //calcule une inter-arrive
            else
            {
             nbOn[numFile] = 1 + (int)(dureeOn / interOn);
             float dureeOff = -log(aleatoire()) / (1.0/(nbOn[numFile] / (lamb*(numFile+1)) - dureeOn));
             //float dureeOff = nbOn[numFile] / (lamb*(numFile+1)) - dureeOn; //constant
             date = interOn + dureeOff;
            }
            nbOn[numFile]--;
          #else
            float date = -log(aleatoire()) / (lamb*(numFile+1)); //calcule une inter-arrive
          #endif
          date += test->getDateArrFile(); //additionne  la date prcdente
          Cell * tempo = new Cell(numFile, id, 'A', date, numFile, date, date, true);
          id++;
          pile->insere(tempo);
          nbGenere[numFile]++;
          if (nbGenere[numFile]==NMax) debitArriveesRoutes[numFile] += (NMax-1) / date;
        }
        break;
      }  //case 'A'
      case 'F':
      {
        //Gestion du nombre de clients dans le systeme
        nbClient[numFile]--;
        tabValeurs[numFile][indice[numFile]].date = test->getDate();
        tabValeurs[numFile][indice[numFile]].nbClients = nbClient[numFile];
        float repo = test->getDate()-test->getDateArrFile();
        cumulReponses[numFile]+=repo;
        if (repo>=10.0) nbReponsesSup10[numFile]++;
        if (repo>=20.0) nbReponsesSup20[numFile]++;
        if (repo>=50.0) nbReponsesSup50[numFile]++;
        indice[numFile]++;
        #ifndef NO_ROUTE
          if (topologie == TOPO1) //Routage topologie 1
          {
            if ( (test->getSource() == numFile) || (test->getSource() == (numFile+NBFILES-1)%NBFILES) ) //file actuelle ou file prcdente
            {
              int numFileSuiv = (numFile+1)%NBFILES;
              pile->insere(new Cell(numFileSuiv, test->getNumProc(), 'A', test->getDate()+delai_arrive, test->getSource(), test->getDateArrReseau(), test->getDate()+delai_arrive, false));
            }
            else if (test->getSource() == (numFile+NBFILES-2)%NBFILES) //2 files avant : sortie
            {
              float rep = test->getDate()-test->getDateArrReseau();
              cumulReponsesRoutes[test->getSource()] += rep;
              if (rep>=10.0) nbReponsesRoutesSup10[test->getSource()]++;
              if (rep>=20.0) nbReponsesRoutesSup20[test->getSource()]++;
              if (rep>=50.0) nbReponsesRoutesSup50[test->getSource()]++;
            }
            else cerr<<"Erreur de route en "<<numFile<<endl;
          }
          else if (topologie == TOPOALEA) //routage alatoire
          {
            if (test->getSource() == numFile) //le message est dans la file o il a t cr
            {
              if (test->isNouveau()) //le paquet vient d'arriver dans la file
              {
                int randome = aleatoireEntier(NBFILES-1); //0..NBFILES-2
                if (randome >= numFile) randome++;
                tableRandoms[randome]++;
                pile->insere(new Cell(randome, test->getNumProc(), 'A', test->getDate()+delai_arrive, test->getSource(), test->getDateArrReseau(), test->getDate()+delai_arrive, false));
              }
              else //sortie
              {
                float rep = test->getDate()-test->getDateArrReseau();
                cumulReponsesRoutes[test->getSource()] += rep;
                if (rep>=10.0) nbReponsesRoutesSup10[test->getSource()]++;
                if (rep>=20.0) nbReponsesRoutesSup20[test->getSource()]++;
                if (rep>=50.0) nbReponsesRoutesSup50[test->getSource()]++;
              }
            }
            else //retour  la source
              pile->insere(new Cell(test->getSource(), test->getNumProc(), 'A', test->getDate()+delai_arrive, test->getSource(), test->getDateArrReseau(), test->getDate()+delai_arrive, false));
          }
          else cerr<<"Erreur de topologie"<<endl;
        #endif
        break;
      } //case 'F'
      /*case 'D' :
      {

         break; //case 'D'
      }*/
      default : cerr<<"Erreur de type"<<endl;
    }  //switch(test->gettype())
    delete test;
    test=pile->premier();
  }
  delete pile;
  cout<<"<TABLE border=\"1\">"<<endl;
  cout<<"<CAPTION>&#955;<SUB>0</SUB>="<<lamb<<"</CAPTION>"<<endl;
  cout<<"<TR><TH>Clients par file = "<<NMax<<"</TH>"<<endl;
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TH>"<<cpt+1<<"</TH>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Dbit d'arrive moyen dans les files</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(nbClientServis[cpt]-1)/dateDerniereArrivee[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Temps de rponse moyen dans les files</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<cumulReponses[cpt]/nbClientServis[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Nombre de clients servis dans les files</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<nbClientServis[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Nombre de clients en attende au maximum par file</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<nbMaxClientsAttente[cpt]-1<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les files dpasse 10</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesSup10[cpt]/nbClientServis[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les files dpasse 20</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesSup20[cpt]/nbClientServis[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les files dpasse 50</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesSup50[cpt]/nbClientServis[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Inter-arrives moyennes dans les files</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<cumulInterArrivees[cpt]/(nbClientServis[cpt]-1)<<"</TD>";
  cout<<"</TR>"<<endl;
  #ifdef FILE_LIMIT
    cout<<"<TR><TH>Taux de perte des paquets par file</TH>";
    for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)pertesFile[cpt]/(nbClientServis[cpt]+pertesFile[cpt])<<"</TD>";
    cout<<"</TR>"<<endl;
  #endif
  cout<<"<TR><TH>Dbit d'arrive moyen dans les routes</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<debitArriveesRoutes[cpt]<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Temps de rponse moyen dans les routes</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<cumulReponsesRoutes[cpt]/(NMax-pertesRoute[cpt])<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les routes dpasse 10</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesRoutesSup10[cpt]/(NMax-pertesRoute[cpt])<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les routes dpasse 20</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesRoutesSup20[cpt]/(NMax-pertesRoute[cpt])<<"</TD>";
  cout<<"</TR>"<<endl;
  cout<<"<TR><TH>Proba que le temps de rponse sur les routes dpasse 50</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)nbReponsesRoutesSup50[cpt]/(NMax-pertesRoute[cpt])<<"</TD>";
  cout<<"</TR>"<<endl;
  #ifdef FILE_LIMIT
    cout<<"<TR><TH>Taux de perte des paquets par route</TH>";
    for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<(float)pertesRoute[cpt]/NMax<<"</TD>";
    cout<<"</TR>"<<endl;
  #endif
  /*cout<<"<TR><TH>Temps de service moyen</TH>";
  for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<cumulTo[cpt]/(nbClientServis[cpt])<<"</TD>";
  cout<<"</TR>"<<endl;
  if (topologie == TOPOALEA)
  {
    cout<<"<TR><TH>Table randoms</TH>";
    for (int cpt=0; cpt<NBFILES; cpt++) cout<<"<TD>"<<tableRandoms[cpt]<<"</TD>";
    cout<<"</TR>"<<endl;
  }*/
  cout<<"</TABLE>"<<endl;

  #ifdef gnuplot
    for (int cpt=0; cpt<NBFILES; cpt++) //(int cpt=0; cpt<NBFILES; cpt++)
    {
      char * pourri = new char[32];
      sprintf(pourri,"Clients%d.dat~",cpt);
      toFic(pourri, tabValeurs[cpt], indice[cpt]);
      char * rahhh = new char[128];
      sprintf(rahhh,"plot \"%s\" with steps;",pourri);
      char * nomFich = new char[32];
      sprintf(nomFich,"commande%d.txt~",cpt);
      ecrireDansFichier(nomFich,rahhh);
      char * bof = new char[32];
      sprintf(bof,"gnuplot -persist commande%d.txt~",cpt);
      system(bof);
    }
    system("sleep 4s");
    system("rm *.*~");
  #endif
}

int main() //int argc, char* argv[]
{
  cerr<<"Indice memoire necessaire "<<(2*NMax*7*sizeof(TDateClient)+2*6*NMax*sizeof(Cell))<<endl;
  randomize();
  #ifdef gnuplot
    system("killall gnuplot_x11"); //destruction des fentres gnuplot existantes
  #endif
  tabValeurs = new TDateClient*[NBFILES];
  for (int cpt = 0; cpt<NBFILES; cpt++)  tabValeurs[cpt]  = new TDateClient[2*NMax*(2+5)] ;
  #ifdef FILE_LIMIT
    capaciteFile++; //on compte le paquet du serveur comme faisant parti de la file
  #endif
  cout<<"<HTML>"<<endl;
  cout<<"<BODY>"<<endl;
  SUJET
  for (int topologie = TOPO1; topologie<=TOPOALEA; topologie++) //TOPO1 .. TOPOALEA
  {
    cout<<"<H3>";
    switch (topologie)
    {
      case TOPO1 : cout<<"Topologie 1"; break;
      case TOPOALEA : cout<<"Topologie 2 routage alatoire"; break;
    }
    cout<<"</H3>"<<endl;
    for (int cpt = 1; cpt<=6; cpt++) // 1 .. 6
    {
      programme(topologie, cpt*lambda0);
      cout<<"<BR/>"<<endl;
    }
    cout<<"<BR/>"<<endl;
  }
  cout<<"</HTML>"<<endl;
  cout<<"</BODY>"<<endl;
}

